#version 450

// ----------------------------------------------------------------------------
// Input Variables
// ----------------------------------------------------------------------------

layout(binding = 0) uniform sampler2D input_image;

// ----------------------------------------------------------------------------
// Output Variables
// ----------------------------------------------------------------------------

// The final output color.
layout(location = 0) out vec4 final_color;

// ----------------------------------------------------------------------------
// Local Variables
// ----------------------------------------------------------------------------

// Gaussian kernel
const float gaussBlurKernel[3][3] = {
	{1.0 / 16.0, 2.0 / 16.0, 1.0 / 16.0},
	{2.0 / 16.0, 4.0 / 16.0, 2.0 / 16.0},
	{1.0 / 16.0, 2.0 / 16.0, 1.0 / 16.0}
};

// Edge detection convolution kernel
const float edgeDetectionKernel[3][3] = {
	{-1.0, -1.0, -1.0},
	{ 2.0,  2.0,  2.0},
	{-1.0, -1.0, -1.0}
};

// ----------------------------------------------------------------------------
// Main Method
// ----------------------------------------------------------------------------

void main() {
	vec3 color = vec3(0.0);

	// Task 7.3: Apply post-process effects (grayscale).
	color = texelFetch(input_image, ivec2(gl_FragCoord.xy), 0).rgb;
	//color.r = gl_FragCoord.x / 1000.0;
	//color.g = gl_FragCoord.y / 1000.0;
	//color.b = 0;
	
	color.r = 50*(1-color.r);
	color.gb = color.rr;
	 //color = vec3(0.3*color.r + 0.5*color.g + 0.1*color.b);
	 //color.rgb = min(color.rgb*7, 1.0);
	 //color.gb = vec2(0);

	// Task 7.3: Apply post-process effects (convolution kernels).
	// for(int i = -1; i <= 1; i++) {
	// 	for(int j = -1; j <= 1; j++) {
	// 		color += edgeDetectionKernel[i + 1][j + 1] * texelFetch(input_image, ivec2(gl_FragCoord.xy) + ivec2(i, j), 0).rgb;
	// 	}
	// }

	final_color = vec4(color, 1.0);	
}